
local function OnInit(inst)
    inst.components.herdmember_dst.task = nil
    inst.components.herdmember_dst:CreateHerd()
end

local HerdMember_dst = Class(function(self, inst)
    self.inst = inst
    self.enabled = true
    self.herd = nil
    self.herdprefab = "beefaloherd_dst"
    self.task = self.inst:DoTaskInTime(5, OnInit)
end)

function HerdMember_dst:OnRemoveFromEntity()
    if self.task ~= nil then
        self.task:Cancel()
        self.task = nil
    end
    self.inst:RemoveTag("herdmember")
end

function HerdMember_dst:SetHerd(herd)
    self.herd = herd
end

function HerdMember_dst:SetHerdPrefab(prefab)
    self.herdprefab = prefab
end

function HerdMember_dst:GetHerd()
    return self.herd
end

function HerdMember_dst:CreateHerd()
    if self.enabled and not self.herd then
        local herd = SpawnPrefab(self.herdprefab)
        if herd then
            herd.Transform:SetPosition(self.inst.Transform:GetWorldPosition() )
            if herd.components.herd_dst then
                herd.components.herd_dst:GatherNearbyMembers()
            end
        end
    end
end

function HerdMember_dst:Enable(enabled)
    if not enabled and self.herd ~= nil then
        self.herd.components.herd_dst:RemoveMember(self.inst)
    elseif enabled and self.herd == nil then
        self.task = self.inst:DoTaskInTime(5, OnInit)
    end
    self.enabled = enabled
    if enabled then
        self.inst:AddTag("herdmember")
    else
        self.inst:RemoveTag("herdmember")
    end
end

function HerdMember_dst:GetDebugString()
    return string.format("herd:%s %s",tostring(self.herd), (not self.enabled) and "disabled" or "")
end

return HerdMember_dst
