local function AnnounceMountHealth(inst, self)
    self._mountannouncetask = nil
    local mount = self:GetMount()
    if mount ~= nil and mount.components.health ~= nil and mount.components.health:GetPercent() < 0.2 then
        inst:PushEvent("mountwounded")
    end
end

local Rider = Class(function(self, inst)
    self.inst = inst
    self.mount = nil
    self.saddle = nil
    self._mountannouncetask = nil
    self._onSaddleChanged = function(mount, data)
        self.saddle = data.saddle
    end
end)

function Rider:OnRemoveFromEntity()
    if self._mountannouncetask ~= nil then
        self._mountannouncetask:Cancel()
        self._mountannouncetask = nil
    end
    self:StopTracking(self.mount)
end

function Rider:StartTracking(mount)
    self:StopTracking(self.mount)
    if mount ~= nil then
        self.inst:ListenForEvent("saddlechanged", self._onSaddleChanged, mount)
        self.saddle = mount.components.rideable ~= nil and mount.components.rideable.saddle or nil
    end
end
function Rider:StopTracking(mount)
    if mount ~= nil then
        self.inst:RemoveEventCallback("saddlechanged", self._onSaddleChanged, mount)
        self.saddle = nil
    end
end

function Rider:GetSaddle()
    return self.saddle
end
local dst_build = 
{
	"wendy",
	"webber",
	"wathgrithr",
	"wx78",
	"wilson",
	"waxwell",
	--"wolfgang",
	"wickerbottom",
	"willow",
	"wes",
	"woodie",
	"puppet",	
}
function Rider:Mount(target, instant)
    if self.riding or target.components.rideable == nil or target.components.rideable:IsBeingRidden() then
        return
    end
    if not target.components.rideable:TestObedience() then
        self.inst:PushEvent("refusedmount", {rider=self.inst,rideable=target})
        target:PushEvent("refusedrider", {rider=self.inst,rideable=target})
        return
    end
    local rideable = target.components.rideable
    local saddler = rideable.saddle.components.saddler

    local x, y, z = self.inst.Transform:GetWorldPosition()
    local tx, ty, tz = target.Transform:GetWorldPosition()

    self.riding = true

    self.inst.AnimState:SetBank("wilsonbeefalo")
	if self.inst and table.contains(dst_build,self.inst.prefab) and not self.inst._xiaoqiangbianshen == true then --兼容皮肤mod
			if self.inst.prefab == "puppet"  then 
				if self.inst.components.puppet_skin ~= nil and self.inst.components.puppet_skin.skin ~= "normal"then
					self.inst.AnimState:SetBuild("puppet_"..self.inst.components.puppet_skin.skin) --傀儡师专属
				else
					self.inst.AnimState:SetBuild("puppet")
				end
			else
			self.inst.AnimState:SetBuild(self.inst.prefab.."_dst")
			end
	end
	self.inst:SetStateGraph("SGwilsonqiniu")

    if target.ApplyBuildOverrides ~= nil then
        target:ApplyBuildOverrides(self.inst.AnimState)
    end
    self.inst.AnimState:OverrideSymbol("swap_saddle", saddler.swapbuild, saddler.swapsymbol)
	if ACTIONS.HACK ~= nil then
	self.inst.components.locomotor:AddSpeedModifier_Additive("saddler", target.components.locomotor.runspeed - 6 + saddler.speedmult)
	else
	self.inst.components.locomotor.bonusspeed = target.components.locomotor.runspeed - 6 + saddler.speedmult
	end
    self.inst.Transform:SetSixFaced()--巨人国没有

    self.inst.sg:GoToState(instant and "idle" or "mount")

    self.inst.DynamicShadow:SetSize(6, 2)

    if self.inst.components.sheltered ~= nil then
        self.inst.components.sheltered:Stop()
    end

    self.inst:AddChild(target)
    target.Transform:SetPosition(0, 0, 0)
    target.Transform:SetRotation(0)
    target:RemoveFromScene()
    if target.components.brain ~= nil then
        BrainManager:Hibernate(target) 
    end
    if target.SoundEmitter ~= nil then
        target.SoundEmitter:KillAllSounds()
    end

    self:StartTracking(target)
    self.mount = target
    target.components.rideable:SetRider(self.inst)

    self.inst.Physics:Teleport(tx, ty, tz)
    self.inst:FacePoint(x, y, z)

    self._mountannouncetask = self.inst:DoTaskInTime(2 + math.random() * 2, AnnounceMountHealth, self)

    self.inst:PushEvent("mountedniu", { target = target })
end

function Rider:Dismount()
    self.inst:PushEvent("dismountniu")
end

function Rider:ActualDismount()
    if not self.riding then
        return
    end
    self.riding = false

    if self._mountannouncetask ~= nil then
        self._mountannouncetask:Cancel()
        self._mountannouncetask = nil
    end

    self.inst.AnimState:SetBank("wilson")
	if self.inst and table.contains(dst_build,self.inst.prefab) and not self.inst._xiaoqiangbianshen == true then --兼容皮肤mod
		if self.inst.prefab == "puppet" then 
			if self.inst.components.puppet_skin ~= nil and self.inst.components.puppet_skin.skin ~= "normal"then
				self.inst.AnimState:SetBuild("puppet_"..self.inst.components.puppet_skin.skin.."_ds") --傀儡师专属
			else
				self.inst.AnimState:SetBuild("puppet_ds")
			end
		else
		self.inst.AnimState:SetBuild(self.inst.prefab)
		end
	end
    if self.mount.ClearBuildOverrides ~= nil then
        self.mount:ClearBuildOverrides(self.inst.AnimState)
    end
	if  ACTIONS.HACK ~= nil then
	self.inst.components.locomotor:RemoveSpeedModifier_Additive("saddler")--巨人国没有
	else
	self.inst.components.locomotor.bonusspeed = 0
	end
    self.inst.AnimState:ClearOverrideSymbol("swap_saddle")
    self.inst.Transform:SetFourFaced()
	self.inst:SetStateGraph("SGwilson")
	self.inst.sg:GoToState("idle")
    self.inst.DynamicShadow:SetSize(1.3, .6)

    if self.inst.components.sheltered ~= nil then
        self.inst.components.sheltered:Start()
    end
    self.mount.components.rideable:SetRider(nil)
    self.inst:RemoveChild(self.mount)
    self.mount:ReturnToScene()

    if self.mount.Physics ~= nil then
        self.mount.Physics:Teleport(self.inst.Transform:GetWorldPosition())
    else
        self.mount.Transform:SetPosition(self.inst.Transform:GetWorldPosition())
    end
    self.mount.Transform:SetRotation(self.inst.Transform:GetRotation())

    if self.mount.components.brain ~= nil then
        BrainManager:Wake(self.mount)
    end
    if not self.mount.components.health:IsDead() then
        self.mount.sg:GoToState("idle")
    end
    local ex_mount = self.mount
    self:StopTracking(ex_mount)
    self.mount = nil
    self.inst:PushEvent("dismountniu", { target = ex_mount })
    return ex_mount
end

function Rider:IsRiding()
    return self.riding
end

function Rider:GetMount()
    return self.mount
end

function Rider:CollectSceneActions(doer, actions,right)
    if right and self.inst == doer and self.inst.components.rider:IsRiding() then
        table.insert(actions, ACTIONS.DISMOUNTNIU)
    end
end

function Rider:OnSave()
    local data = {}
    if self.mount ~= nil then
        data.mount = self.mount:GetSaveRecord()
    end
    return data
end

function Rider:OnLoad(data)
    if data and data.mount ~= nil then
        local mount = SpawnSaveRecord(data.mount)
        --self:Mount(mount, true)
    end
end

return Rider
