
local ImageButton = require "widgets/imagebutton"
local Widget = require "widgets/widget"
local UIAnim = require "widgets/uianim"
local Image = require "widgets/image"
local Text = require "widgets/text"
Dismountniu = Class(Widget, function(self,owner)
	Widget._ctor(self, "Dismountniu",owner)
	self.owner = owner
    self.root = self:AddChild(Widget("ROOT"))
    self.root:SetVAnchor(ANCHOR_MIDDLE)
    self.root:SetHAnchor(ANCHOR_MIDDLE)
    self.root:SetPosition(325,-275,0)
    self.root:SetScaleMode(SCALEMODE_PROPORTIONAL)
	
    self.mountbg = self.root:AddChild( Image( "images/678.xml", "678.tex" ) )
    self.mountbg:SetPosition( 0,0,0 )

	local SAVESLOT  = "images/dismountniu.xml"
	self.dismount = self.root:AddChild(ImageButton(SAVESLOT , "dismountniu.tex", "dismountniu.tex", "dismountniu.tex"))
	self.dismount:SetPosition(-30,0,0)
	self.dismount:SetScale(0.84,0.84,0.84)
	self.dismount:SetOnClick( function() 
	if self.owner.components.playercontroller.enabled == true then
		self.owner:PushEvent("dismountniu") 
	end
	end)	

	self.mounthunger = self.root:AddChild(UIAnim())
	self.mounthunger:GetAnimState():SetBank("hunger")
	self.mounthunger:GetAnimState():SetBuild("hunger")
	self.mounthunger:GetAnimState():PlayAnimation("anim")
	self.mounthunger:SetPosition(20,0,0)
	self.mounthunger:SetScale(0.7,0.7,0.7)
	self.mounthunger:SetClickable(false)

	self.mounthelath = self.root:AddChild(UIAnim())
	self.mounthelath:GetAnimState():SetBank("health")
	self.mounthelath:GetAnimState():SetBuild("health")
	self.mounthelath:GetAnimState():PlayAnimation("anim")
	self.mounthelath:SetPosition(70,0,0)
	self.mounthelath:SetScale(0.7,0.7,0.7)
	self.mounthelath:SetClickable(false)
	self:Hide()
end)

function Dismountniu:OnUpdate(dt)	
	local helathpercent
	local hungerpercent
	if self.owner.components.rider ~= nil and self.owner.components.rider.mount ~= nil  then
		helathpercent = self.owner.components.rider.mount.components.health:GetPercent()
		hungerpercent = self.owner.components.rider.mount.components.hunger:GetPercent()
	else
		helathpercent = 0
		hungerpercent = 0
	end
	self.mounthelath:GetAnimState():SetPercent("anim", 1-helathpercent)
	self.mounthunger:GetAnimState():SetPercent("anim", 1-hungerpercent)
end

function Dismountniu:Close()
	self:Hide()
end

return Dismountniu